/*****************************************************************************

襭 夨 ⥬
 ࠨ᪨ ࠢ ()
⭠ 奬                  v. 3.0

(c) 2002 ⠭᫠    <xstazz@hotbox.ru>

ணࠬ ࠡ  http://vt.spbgmtu.ru

*****************************************************************************/


#include <conio.h>
#include "matrix6.cpp"


//襭 夨쭮 ⥬
TMatrix<double> linearSolve3DiagCompact(TMatrix<double> &a,// .
					TMatrix<double> &b)//ࠢ 
{
   int n=a.getSizeRow();
   TMatrix<double> mu(n,1), g(n,1), x(n,1);

   mu[1]=1./a(1,1);
   g[1]=mu[1]*b[1];

   for(int k=2; k<=n; k++)
   {
      mu[k]=1./(a(k,k)-a(k,k-1)*mu[k-1]);
      g[k]=mu[k]*(b[k]-a(k,k-1)*g[k-1]);
   }

   x[n]=g[n];

   for(k=n-1; k>=1; k--)
   {
      x[k]=g[k]-mu[k]*x[k+1];
   }

   return x;
}


void main(void)
{
   char ch;
   TMatrix<double> a_b;

   cout.setf(ios::showpoint);

   for(;;)
   {
      clrscr();
      cout<<"襭 夨 "<<endl
	 <<"⭠ 奬"<<endl<<endl
	 <<"1   -    䠩"<<endl
	 <<"2   -  "<<endl
	 <<"Esc - 室"<<endl<<endl<<endl;

      do
      {
	 ch=getch();
      }
      while(ch!='1' && ch!='2' && ch!=27);

      switch(ch)
      {
	 case '1':
	 {
	    clrscr();
	    char str[20];
	    cout<<"  䠩:"<<endl;
	    cin>>str;
	    ifstream in_file(str);
	    if(in_file)
	    {
	       int n;
	       in_file>>n;
	       a_b.setSize(n,n+1);
	       a_b.readArray(in_file);
	       a_b.writeArray(cout);
	    }
	    else
	    {
	       cout<<"   䠩 \""<<str<<"\""<<endl;
	    }
	    getch();
	    break;
	 }
	 case '2':
	 {
	    TMatrix<double> x;
	    clrscr();
	    cout<<"襭 "<<endl;
	    cout<<"७  ⥬:"<<endl;
	    a_b.writeArray(cout);

	    int n=a_b.getSizeRow();
	    TMatrix<double> a(a_b.getPart(1,1,n,n)), b(a_b.getCol(n+1));
	    x=linearSolve3DiagCompact(a,b);

	    cout<<"襭: "<<endl;
	    x.writeArray(cout);

	    ofstream out_file("result.txt");
	    if(out_file)
	    {
	       out_file<<"襭 "<<endl;
	       out_file<<"७  ⥬:"<<endl;
	       a_b.writeArray(out_file);
	       out_file<<"襭: "<<endl;
	       x.writeArray(out_file);
	    }
	    else
	    {
	       cout<<"  ᮧ 䠩 \"result.txt\""<<endl;
	    }

	    getch();
	    break;
	 }
	 case 27:
	 {
	    return;
	 }
      }
   }
}
